/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["jquery.sap.global","sap/ui/thirdparty/sinon","sap/ui/test/_LogCollector"],function($,s,_){"use strict";var l=$.sap.log.getLogger("sap.ui.test._XHRCounter",_.DEFAULT_LEVEL_FOR_OPA_LOGGERS);var x=[];var f=[];var u=s.useFakeXMLHttpRequest;s.useFakeXMLHttpRequest=function(){var F=u.apply(this,arguments);h();return F;};function h(){var d=XMLHttpRequest.restore;if(d){XMLHttpRequest.restore=function(){var r=d.apply(this,arguments);f.length=0;return r;};}}h();var o=XMLHttpRequest.prototype.send;XMLHttpRequest.prototype.send=function(){this.addEventListener("readystatechange",function(){if(this.readyState===4){x.splice(x.indexOf(this),1);}});x.push(this);return o.apply(this,arguments);};var O=XMLHttpRequest.prototype.open;XMLHttpRequest.prototype.open=function(m,U){this.method=m;this.url=U;return O.apply(this,arguments);};var a=s.FakeXMLHttpRequest.prototype.send;s.FakeXMLHttpRequest.prototype.send=function(){this.addEventListener("readystatechange",function(){if(this.readyState===4){f.splice(x.indexOf(this),1);}});f.push(this);return a.apply(this,arguments);};function b(){var L="There are '"+x.length+"' open XHRs and '"+f.length+"' open FakeXHRs.";x.forEach(function(X){L+=c(X);});f.forEach(function(X){L+=c(X,true);});l.debug(L);}function c(X,i){var m=i?"\nFakeXHR: ":"\nXHR: ";m+="URL: '"+X.url+"' Method: '"+X.method+"'";return m;}return{hasPendingRequests:function(){var H=x.length>0||f.length>0;if(H){b();}return H;}};},true);
